;;; guile-irrlicht --- FFI bindings for Irrlicht Engine
;;; Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>
;;;
;;; This file is part of guile-irrlicht.
;;;
;;; Guile-irrlicht is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU Lesser General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; Guile-irrlicht is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with guile-irrlicht.  If not, see
;;; <http://www.gnu.org/licenses/>.


(define-module (irrlicht io)
  #:use-module (oop goops)
  #:use-module (ice-9 optargs)
  #:use-module (irrlicht foreign)
  #:use-module ((irrlicht irr) #:select (<reference-counted>)))


;; IAttributeExchangingObject
(define-class <attribute-exchanging-object> (<reference-counted>)
  (irr-class #:init-value "IAttributeExchangingObject"))

(export <attribute-exchanging-object>)


;;IFileArchive
(define-class <file-archive> (<reference-counted>)
  (irr-class #:init-value "IFileArchive"))

(export <file-archive>)


;;IFileSystem
(define-class <file-system> (<reference-counted>)
  (irr-class #:init-value "IFileSystem"))

(define-method (add-file-archive! (file-system <file-system>) filename . rest)
  (let-keywords rest #f
        ((ignore-case #t)
         (ignore-paths #t)
         (archive-type 'unknown)
         (password "")
         (ret-archive (make <file-archive>)))
    (let ((addFileArchive (get-irrlicht-proc "addFileArchive" file-system)))
      (addFileArchive
       file-system filename ignore-case ignore-paths archive-type password ret-archive))))

(export <file-system> add-file-archive!)
