/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "animated-mesh.h"
#include "gsubr.h"
#include "wrapped.h"

using namespace irr;

SCM
IAnimatedMesh_setAnimationSpeed (SCM animated_mesh,
                                 SCM frames_per_second)
{
  ((scene::IAnimatedMesh*)scm_to_irr_pointer (animated_mesh))->
    setAnimationSpeed (scm_to_double (frames_per_second));
  return SCM_UNSPECIFIED;
}

void
init_animated_mesh (void)
{
  DEFINE_GSUBR ("IAnimatedMesh_setAnimationSpeed", 2, 0, 0, IAnimatedMesh_setAnimationSpeed);
}
