/* guile-irrlicht --- GNU Guile bindings for Irrlicht Engine

   Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>

   This file is part of guile-irrlicht.

   guile-irrlicht is free software; you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as
   published by the Free Software Foundation; either version 3 of the
   License, or (at your option) any later version.

   guile-irrlicht is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with guile-irrlicht. If not, see
   <http://www.gnu.org/licenses/>.
*/

#include <irrlicht/irrlicht.h>
#include <libguile.h>
#include "wrapped.h"

using namespace irr;

/* Make a GOOPS instance from a C++ object pointer */
SCM
scm_from_irr_pointer (const char* class_name, void* pointer)
{
  SCM scm_class = scm_variable_ref (scm_c_public_lookup ("irrlicht", class_name));
  SCM k_pointer = scm_from_utf8_keyword ("irr-pointer");
  SCM scm_pointer = scm_from_pointer (pointer, NULL);
  return scm_make (scm_list_3 (scm_class, k_pointer, scm_pointer));
}

/* Extract C++ irrlicht object pointer from Guile object */
void*
scm_to_irr_pointer (SCM obj)
{
  SCM slot = scm_slot_ref (obj, scm_from_utf8_symbol ("irr-pointer"));
  return scm_to_pointer (slot);
}
